Index: issm/trunk/src/c/solutions/surfaceslope_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/surfaceslope_core.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/surfaceslope_core.cpp	(revision 13395)
@@ -5,5 +5,5 @@
 #include "./solutions.h"
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
Index: issm/trunk/src/c/solutions/thermal_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal_core.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/thermal_core.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
Index: issm/trunk/src/c/solutions/transient_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/transient_core.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/transient_core.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -24,5 +24,5 @@
 	/*parameters: */
 	IssmDouble starttime,finaltime,dt,yts;
-	bool   isdiagnostic,isprognostic,isthermal,isgroundingline,isenthalpy;
+	bool   isdiagnostic,isprognostic,isthermal,isgroundingline,isenthalpy,isdelta18o;
 	bool   save_results,dakota_analysis;
 	bool   time_adapt=false;
@@ -53,4 +53,5 @@
 	femmodel->parameters->FindParam(&numoutputs,TransientNumRequestedOutputsEnum);
 	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,TransientRequestedOutputsEnum);
+	femmodel->parameters->FindParam(&isdelta18o,SurfaceforcingsIsdelta18oEnum);
 
 	/*initialize: */
@@ -103,8 +104,8 @@
 			}
 			#else
-			_error2_("ISSM was not compiled with thermal capabilities. Exiting");
+			_error_("ISSM was not compiled with thermal capabilities. Exiting");
 			#endif
 		}
-
+		
 		if(isdiagnostic){
 			if(VerboseSolution()) _pprintLine_("   computing new velocity");
@@ -112,5 +113,5 @@
 			diagnostic_core(femmodel);
 			#else
-			_error2_("ISSM was not compiled with diagnostic capabilities. Exiting");
+			_error_("ISSM was not compiled with diagnostic capabilities. Exiting");
 			#endif
 		}
@@ -128,5 +129,5 @@
 			GroundinglineMigrationx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
 			#else
-			_error2_("ISSM was not compiled with grounding line migration capabilities. Exiting");
+			_error_("ISSM was not compiled with grounding line migration capabilities. Exiting");
 			#endif
 		}
@@ -141,4 +142,9 @@
 			RequestedOutputsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,requested_outputs,numoutputs);
 
+			if(isdelta18o){
+			        InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceforcingsMonthlytemperaturesEnum);
+			        InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceforcingsPrecipitationEnum);
+			}
+
 			if(VerboseSolution()) _pprintLine_("   saving temporary results");
 			OutputResultsx(femmodel->elements, femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,femmodel->results);
@@ -146,4 +152,6 @@
 	}
 
+	RequestedDependentsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	
 	/*Free ressources:*/
 	xDelete<int>(requested_outputs);
Index: issm/trunk/src/c/solvers/solver_adjoint_linear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_adjoint_linear.cpp	(revision 12709)
+++ issm/trunk/src/c/solvers/solver_adjoint_linear.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../modules/modules.h"
@@ -13,11 +13,11 @@
 
 	/*intermediary: */
-	Matrix*  Kff = NULL;
-	Matrix*  Kfs = NULL;
-	Vector*  ug  = NULL;
-	Vector*  uf  = NULL;
-	Vector*  pf  = NULL;
-	Vector*  df  = NULL;
-	Vector*  ys  = NULL;
+	Matrix<IssmDouble>*  Kff = NULL;
+	Matrix<IssmDouble>*  Kfs = NULL;
+	Vector<IssmDouble>*  ug  = NULL;
+	Vector<IssmDouble>*  uf  = NULL;
+	Vector<IssmDouble>*  pf  = NULL;
+	Vector<IssmDouble>*  df  = NULL;
+	Vector<IssmDouble>*  ys  = NULL;
 	int  configuration_type;
 
Index: issm/trunk/src/c/solvers/solver_linear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_linear.cpp	(revision 12709)
+++ issm/trunk/src/c/solvers/solver_linear.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../modules/modules.h"
@@ -11,11 +11,11 @@
 
 	/*intermediary: */
-	Matrix*  Kff = NULL;
-	Matrix*  Kfs = NULL;
-	Vector*  ug  = NULL;
-	Vector*  uf  = NULL;
-	Vector*  pf  = NULL;
-	Vector*  df  = NULL;
-	Vector*  ys  = NULL;
+	Matrix<IssmDouble>*  Kff = NULL;
+	Matrix<IssmDouble>*  Kfs = NULL;
+	Vector<IssmDouble>*  ug  = NULL;
+	Vector<IssmDouble>*  uf  = NULL;
+	Vector<IssmDouble>*  pf  = NULL;
+	Vector<IssmDouble>*  df  = NULL;
+	Vector<IssmDouble>*  ys  = NULL;
 	int  configuration_type;
 
@@ -29,4 +29,9 @@
 	Solverx(&uf, Kff, pf, NULL, df, femmodel->parameters); 
 	xdelete(&Kff); xdelete(&pf); xdelete(&df);
+//#ifdef  _HAVE_ADOLC_
+//        for (int i =0; i<uf->svector->M; ++i) {
+//          ADOLC_DUMP_MACRO(uf->svector->vector[i]);
+//        }
+//#endif
 	Mergesolutionfromftogx(&ug, uf,ys,femmodel->nodes,femmodel->parameters);xdelete(&uf); xdelete(&ys);
 	InputUpdateFromSolutionx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,ug); 
Index: issm/trunk/src/c/solvers/solver_newton.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_newton.cpp	(revision 12709)
+++ issm/trunk/src/c/solvers/solver_newton.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -18,16 +18,16 @@
 	int    count;
 	IssmDouble kmax;
-	Matrix* Kff = NULL;
-	Matrix* Kfs    = NULL;
-	Matrix* Jff = NULL;
-	Vector* ug  = NULL;
-	Vector* old_ug = NULL;
-	Vector* uf  = NULL;
-	Vector* old_uf = NULL;
-	Vector* duf = NULL;
-	Vector* pf  = NULL;
-	Vector* pJf    = NULL;
-	Vector* df  = NULL;
-	Vector* ys  = NULL;
+	Matrix<IssmDouble>* Kff = NULL;
+	Matrix<IssmDouble>* Kfs    = NULL;
+	Matrix<IssmDouble>* Jff = NULL;
+	Vector<IssmDouble>* ug  = NULL;
+	Vector<IssmDouble>* old_ug = NULL;
+	Vector<IssmDouble>* uf  = NULL;
+	Vector<IssmDouble>* old_uf = NULL;
+	Vector<IssmDouble>* duf = NULL;
+	Vector<IssmDouble>* pf  = NULL;
+	Vector<IssmDouble>* pJf    = NULL;
+	Vector<IssmDouble>* df  = NULL;
+	Vector<IssmDouble>* ys  = NULL;
 
 	/*parameters:*/
@@ -71,5 +71,5 @@
 			int tempStep=1;
 			IssmDouble tempTime=1.0;
-			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
+			femmodel->results->AddObject(new GenericExternalResult<bool>(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
 		}
@@ -79,5 +79,5 @@
 			int tempStep=1;
 			IssmDouble tempTime=1.0;
-			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
+			femmodel->results->AddObject(new GenericExternalResult<bool>(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
 		}
Index: issm/trunk/src/c/solvers/solver_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_nonlinear.cpp	(revision 12709)
+++ issm/trunk/src/c/solvers/solver_nonlinear.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -14,13 +14,13 @@
 
 	/*intermediary: */
-	Matrix* Kff = NULL;
-	Matrix* Kfs = NULL;
-	Vector* ug  = NULL;
-	Vector* old_ug = NULL;
-	Vector* uf  = NULL;
-	Vector* old_uf = NULL;
-	Vector* pf  = NULL;
-	Vector* df  = NULL;
-	Vector* ys  = NULL;
+	Matrix<IssmDouble>* Kff = NULL;
+	Matrix<IssmDouble>* Kfs = NULL;
+	Vector<IssmDouble>* ug  = NULL;
+	Vector<IssmDouble>* old_ug = NULL;
+	Vector<IssmDouble>* uf  = NULL;
+	Vector<IssmDouble>* old_uf = NULL;
+	Vector<IssmDouble>* pf  = NULL;
+	Vector<IssmDouble>* df  = NULL;
+	Vector<IssmDouble>* ys  = NULL;
 	
 	Loads* loads=NULL;
@@ -89,5 +89,5 @@
 			int tempStep=1;
 			IssmDouble tempTime=1.0;
-			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
+			femmodel->results->AddObject(new GenericExternalResult<bool>(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
 		}
@@ -100,5 +100,5 @@
 			int tempStep=1;
 			IssmDouble tempTime=1.0;
-			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
+			femmodel->results->AddObject(new GenericExternalResult<bool>(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
 		}
Index: issm/trunk/src/c/solvers/solver_stokescoupling_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_stokescoupling_nonlinear.cpp	(revision 12709)
+++ issm/trunk/src/c/solvers/solver_stokescoupling_nonlinear.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../io/io.h"
@@ -14,18 +14,18 @@
 
 	/*intermediary: */
-	Matrix*  Kff_horiz = NULL;
-	Matrix* Kfs_horiz   = NULL;
-	Vector*  ug_horiz  = NULL;
-	Vector*  uf_horiz  = NULL;
-	Vector*  old_uf_horiz = NULL;
-	Vector*  pf_horiz  = NULL;
-	Vector*  df_horiz  = NULL;
-	Matrix*  Kff_vert  = NULL;
-	Matrix*  Kfs_vert  = NULL;
-	Vector*  ug_vert   = NULL;
-	Vector*  uf_vert   = NULL;
-	Vector*  pf_vert   = NULL;
-	Vector*  df_vert   = NULL;
-	Vector*  ys   = NULL;
+	Matrix<IssmDouble>*  Kff_horiz = NULL;
+	Matrix<IssmDouble>* Kfs_horiz   = NULL;
+	Vector<IssmDouble>*  ug_horiz  = NULL;
+	Vector<IssmDouble>*  uf_horiz  = NULL;
+	Vector<IssmDouble>*  old_uf_horiz = NULL;
+	Vector<IssmDouble>*  pf_horiz  = NULL;
+	Vector<IssmDouble>*  df_horiz  = NULL;
+	Matrix<IssmDouble>*  Kff_vert  = NULL;
+	Matrix<IssmDouble>*  Kfs_vert  = NULL;
+	Vector<IssmDouble>*  ug_vert   = NULL;
+	Vector<IssmDouble>*  uf_vert   = NULL;
+	Vector<IssmDouble>*  pf_vert   = NULL;
+	Vector<IssmDouble>*  df_vert   = NULL;
+	Vector<IssmDouble>*  ys   = NULL;
 	bool converged;
 	int  constraints_converged;
Index: issm/trunk/src/c/solvers/solver_thermal_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 12709)
+++ issm/trunk/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -12,15 +12,15 @@
 
 	/*solution : */
-	Vector* tg=NULL; 
-	Vector* tf=NULL; 
-	Vector* tf_old=NULL; 
-	Vector* ys=NULL; 
+	Vector<IssmDouble>* tg=NULL; 
+	Vector<IssmDouble>* tf=NULL; 
+	Vector<IssmDouble>* tf_old=NULL; 
+	Vector<IssmDouble>* ys=NULL; 
 	IssmDouble melting_offset;
 
 	/*intermediary: */
-	Matrix* Kff=NULL;
-	Matrix* Kfs=NULL;
-	Vector* pf=NULL;
-	Vector* df=NULL;
+	Matrix<IssmDouble>* Kff=NULL;
+	Matrix<IssmDouble>* Kfs=NULL;
+	Vector<IssmDouble>* pf=NULL;
+	Vector<IssmDouble>* df=NULL;
 
 	bool converged;
Index: issm/trunk/src/c/solvers/solvers.h
===================================================================
--- issm/trunk/src/c/solvers/solvers.h	(revision 12709)
+++ issm/trunk/src/c/solvers/solvers.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define SOLVERS_H_
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 
Index: issm/trunk/src/c/toolkits/issm/SeqMat.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/SeqMat.h	(revision 12709)
+++ issm/trunk/src/c/toolkits/issm/SeqMat.h	(revision 13395)
@@ -1,4 +1,4 @@
 /*!\file:  SeqMat.h
- * \brief wrapper to SeqMat objects, which are just wrappers to a simple IssmDouble* buffer.
+ * \brief wrapper to SeqMat objects, which are just wrappers to a simple IssmDouble or IssmPDouble* buffer.
  */ 
 
@@ -14,9 +14,17 @@
 #endif
 
-#include "../toolkitsenums.h"
+#include "../../shared/Exceptions/exceptions.h"
+#include "../../shared/MemOps/xMemCpy.h"
+#include "../../shared/Alloc/alloc.h"
+#include "../../include/macros.h"
+#include "./SeqVec.h"
 
 /*}}}*/
-class SeqVec;
-
+
+/*We need to template this class, in case we want to create Matrices that hold IssmDouble* matrix or IssmPDouble* matrix. 
+  Such matrices would be useful for use without or with the matlab or python interface (which do not care for IssmDouble types, 
+  but only rely on IssmPDouble types)*/
+
+template <class doubletype> 
 class SeqMat{
 
@@ -24,28 +32,200 @@
 	
 		int M,N; 
-		IssmDouble* matrix; 
-
-		/*SeqMat constructors, destructors {{{*/
-		SeqMat();
-		SeqMat(int M,int N);
-		SeqMat(int M,int N,IssmDouble sparsity);
-		SeqMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity);
-		SeqMat(int M,int N,int connectivity,int numberofdofspernode);
-		~SeqMat();
-		/*}}}*/
-		/*SeqMat specific routines {{{*/
-		void Echo(void);
-		void Assemble(void);
-		IssmDouble Norm(NormMode norm_type);
-		void GetSize(int* pM,int* pN);
-		void GetLocalSize(int* pM,int* pN);
-		void MatMult(SeqVec* X,SeqVec* AX);
-		SeqMat* Duplicate(void);
-		IssmDouble* ToSerial(void);
-		void SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode);
-		void Convert(MatrixType type);
-		/*}}}*/
+		doubletype* matrix;  /*here, doubletype is either IssmDouble or IssmPDouble*/
+
+		/*SeqMat constructors, destructors*/
+		/*FUNCTION SeqMat(){{{*/
+		SeqMat(){
+
+			this->M=0;
+			this->N=0;
+			this->matrix=NULL;
+		}
+		/*}}}*/
+		/*FUNCTION SeqMat(int M,int N){{{*/
+		SeqMat(int pM,int pN){
+
+			this->M=pM;
+			this->N=pN;
+			this->matrix=NULL;
+			if(M*N) this->matrix=xNewZeroInit<doubletype>(pM*pN);
+		}
+		/*}}}*/
+		/*FUNCTION SeqMat(int M,int N, doubletype sparsity){{{*/
+		SeqMat(int pM,int pN, doubletype sparsity){
+
+			this->M=pM;
+			this->N=pN;
+			this->matrix=NULL;
+			if(M*N) this->matrix=xNewZeroInit<doubletype>(pM*pN);
+		}
+		/*}}}*/
+		/*FUNCTION SeqMat(doubletype* serial_mat,int M,int N,doubletype sparsity){{{*/
+		SeqMat(doubletype* serial_mat,int pM,int pN,doubletype sparsity){
+
+			int i,j;
+
+			this->M=pM;
+			this->N=pN;
+			this->matrix=NULL;
+			if(M*N){
+				this->matrix=xNewZeroInit<doubletype>(pM*pN);
+				xMemCpy<doubletype>(this->matrix,serial_mat,pM*pN);
+			}
+
+		}
+		/*}}}*/
+		/*FUNCTION SeqMat(int M,int N, int connectivity, int numberofdofspernode){{{*/
+		SeqMat(int pM,int pN, int connectivity,int numberofdofspernode){
+
+			this->M=pM;
+			this->N=pN;
+			this->matrix=NULL;
+			if(M*N) this->matrix=xNewZeroInit<doubletype>(pM*pN);
+		}
+		/*}}}*/
+		/*FUNCTION ~SeqMat(){{{*/
+		~SeqMat(){
+
+			xDelete<doubletype>(this->matrix);
+			M=0;
+			N=0;
+		}
+		/*}}}*/
+
+		/*SeqMat specific routines */
+		/*FUNCTION Echo{{{*/
+		void Echo(void){
+
+			int i,j;
+			_printLine_("SeqMat size " << this->M << "-" << this->N);
+			for(i=0;i<M;i++){
+				for(j=0;j<N;j++){
+					_printString_(this->matrix[N*i+j] << " ");
+				}
+				_printLine_("");
+			}
+		}
+		/*}}}*/
+		/*FUNCTION Assemble{{{*/
+		void Assemble(void){
+
+			/*do nothing*/
+
+		}
+		/*}}}*/
+		/*FUNCTION Norm{{{*/
+		doubletype Norm(NormMode mode){
+
+			doubletype norm;
+			doubletype absolute;
+			int i,j;
+
+			switch(mode){
+				case NORM_INF:
+					norm=0;
+					for(i=0;i<this->M;i++){
+						absolute=0;
+						for(j=0;j<this->N;j++){
+							absolute+=fabs(this->matrix[N*i+j]);
+						}
+						norm=max(norm,absolute);
+					}
+					return norm;
+					break; 
+				default:
+					_error_("unknown norm !");
+					break;
+			}
+		}
+		/*}}}*/
+		/*FUNCTION GetSize{{{*/
+		void GetSize(int* pM,int* pN){
+
+			*pM=this->M;
+			*pN=this->N;
+
+		}
+		/*}}}*/
+		/*FUNCTION GetLocalSize{{{*/
+		void GetLocalSize(int* pM,int* pN){
+
+			*pM=this->M;
+			*pN=this->N;
+
+		}
+		/*}}}*/
+		/*FUNCTION MatMult{{{*/
+		void MatMult(SeqVec<doubletype>* X,SeqVec<doubletype>* AX){
+
+			int i,j;
+			int XM,AXM;
+			doubletype dummy;
+
+			X->GetSize(&XM);
+			AX->GetSize(&AXM);
+
+			if(M!=AXM)_error_("A and AX should have the same number of rows!");
+			if(N!=XM)_error_("A and X should have the same number of columns!");
+
+			for(i=0;i<M;i++){
+				dummy=0;
+				for(j=0;j<N;j++){
+					dummy+= this->matrix[N*i+j]*X->vector[j];
+				}
+				AX->vector[i]=dummy;
+			}
+
+		}
+		/*}}}*/
+		/*FUNCTION Duplicate{{{*/
+		SeqMat* Duplicate(void){
+
+			doubletype dummy=0;
+
+			return new SeqMat(this->matrix,this->M,this->N,dummy);
+
+		}
+		/*}}}*/
+		/*FUNCTION ToSerial{{{*/
+		doubletype* ToSerial(void){
+
+			doubletype* buffer=NULL;
+
+			if(this->M*this->N){
+				buffer=xNew<doubletype>(this->M*this->N);
+				xMemCpy<doubletype>(buffer,this->matrix,this->M*this->N);
+			}
+			return buffer;
+
+		}
+		/*}}}*/
+		/*FUNCTION SetValues{{{*/
+		void SetValues(int m,int* idxm,int n,int* idxn,doubletype* values,InsMode mode){
+
+			int i,j;
+			switch(mode){
+				case ADD_VAL:
+					for(i=0;i<m;i++) for(j=0;j<n;j++) this->matrix[N*idxm[i]+idxn[j]]+=values[n*i+j];
+					break;
+				case INS_VAL:
+					for(i=0;i<m;i++) for(j=0;j<n;j++) this->matrix[N*idxm[i]+idxn[j]]=values[n*i+j];
+					break;
+				default:
+					_error_("unknown insert mode!");
+					break;
+			}
+
+		}
+		/*}}}*/
+		/*FUNCTION Convert{{{*/
+		void Convert(MatrixType type){
+
+			/*do nothing*/
+
+		}
+		/*}}}*/		
 
 };
-		
+
 #endif //#ifndef _SEQMAT_H_
Index: issm/trunk/src/c/toolkits/issm/SeqVec.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/SeqVec.h	(revision 12709)
+++ issm/trunk/src/c/toolkits/issm/SeqVec.h	(revision 13395)
@@ -14,41 +14,247 @@
 #endif
 
-#include "../toolkitsenums.h"
+#include "../../shared/Exceptions/exceptions.h"
+#include "../../shared/MemOps/xMemCpy.h"
+#include "../../shared/Alloc/alloc.h"
+#include "../../include/macros.h"
 
 /*}}}*/
 
+/*We need to template this class, in case we want to create vectors that hold IssmDouble* matrix or IssmPDouble* matrix. 
+  Such vectors would be useful for use without or with the matlab or python interface (which do not care for IssmDouble types, 
+  but only rely on IssmPDouble types)*/
+
+template <class doubletype> 
 class SeqVec{
 
 	public:
 	
-		IssmDouble* vector;
+		doubletype* vector;
 		int M;
 
-		/*SeqVec constructors, destructors {{{*/
-		SeqVec();
-		SeqVec(int M,bool fromlocalsize=false);
-		SeqVec(IssmDouble* buffer, int M);
-		~SeqVec();
-		/*}}}*/
-		/*SeqVec specific routines {{{*/
-		void Echo(void);
-		void Assemble(void);
-		void SetValues(int ssize, int* list, IssmDouble* values, InsMode mode);
-		void SetValue(int dof, IssmDouble value, InsMode  mode);
-		void GetValue(IssmDouble* pvalue, int dof);
-		void GetSize(int* pM);
-		void GetLocalSize(int* pM);
-		SeqVec* Duplicate(void);
-		void Set(IssmDouble value);
-		void AXPY(SeqVec* X, IssmDouble a);
-		void AYPX(SeqVec* X, IssmDouble a);
-		IssmDouble* ToMPISerial(void);
-		void Copy(SeqVec* to);
-		IssmDouble Norm(NormMode norm_type);
-		void Scale(IssmDouble scale_factor);
-		void PointwiseDivide(SeqVec* x,SeqVec* y);
-		IssmDouble Dot(SeqVec* vector);
+		/*SeqVec constructors, destructors*/
+		/*FUNCTION SeqVec(){{{*/
+		SeqVec(){
+
+			this->M=0;
+			this->vector=NULL;
+		}
+		/*}}}*/
+		/*FUNCTION SeqVec(int M){{{*/
+		SeqVec(int pM){
+
+			this->M=pM;
+			this->vector=NULL;
+			if(this->M) this->vector=xNewZeroInit<doubletype>(pM);
+		}
+		/*}}}*/
+		/*FUNCTION SeqVec(int M,bool fromlocalsize){{{*/
+		SeqVec(int pM,bool fromlocalsize){
+
+			this->M=pM;
+			this->vector=NULL;
+			if(this->M) this->vector=xNewZeroInit<doubletype>(pM);
+		}
+		/*}}}*/
+		/*FUNCTION SeqVec(doubletype* serial_vec,int M){{{*/
+		SeqVec(doubletype* buffer,int pM){
+
+			int i,j;
+
+			this->M=pM;
+			this->vector=NULL;
+			if(this->M){
+				this->vector=xNew<doubletype>(pM);
+				xMemCpy<doubletype>(this->vector,buffer,pM);
+			}
+		}
+		/*}}}*/
+		/*FUNCTION ~SeqVec(){{{*/
+		~SeqVec(){
+			xDelete<doubletype>(this->vector);
+			M=0;
+		}
+		/*}}}*/
+
+		/*SeqVec specific routines*/
+		/*FUNCTION Echo{{{*/
+		void Echo(void){
+
+			int i;
+			_printLine_("SeqVec size " << this->M);
+			for(i=0;i<M;i++){
+				_printString_(vector[i] << "\n ");
+			}
+		}
+		/*}}}*/
+		/*FUNCTION Assemble{{{*/
+		void Assemble(void){
+
+			/*do nothing*/
+
+		}
+		/*}}}*/
+		/*FUNCTION SetValues{{{*/
+		void SetValues(int ssize, int* list, doubletype* values, InsMode mode){
+
+			int i;
+			switch(mode){
+				case ADD_VAL:
+					for(i=0;i<ssize;i++) this->vector[list[i]]+=values[i];
+					break;
+				case INS_VAL:
+					for(i=0;i<ssize;i++) this->vector[list[i]]=values[i];
+					break;
+				default:
+					_error_("unknown insert mode!");
+					break;
+			}
+
+		}
+		/*}}}*/
+		/*FUNCTION SetValue{{{*/
+		void SetValue(int dof, doubletype value, InsMode mode){
+
+			switch(mode){
+				case ADD_VAL:
+					this->vector[dof]+=value;
+					break;
+				case INS_VAL:
+					this->vector[dof]=value;
+					break;
+				default:
+					_error_("unknown insert mode!");
+					break;
+			}
+		}
+		/*}}}*/
+		/*FUNCTION GetValue{{{*/
+		void GetValue(doubletype* pvalue,int dof){
+
+			*pvalue=this->vector[dof];
+
+		}
+		/*}}}*/
+		/*FUNCTION GetSize{{{*/
+		void GetSize(int* pM){
+
+			*pM=this->M;
+
+		}
+		/*}}}*/
+		/*FUNCTION GetLocalSize{{{*/
+		void GetLocalSize(int* pM){
+
+			*pM=this->M;
+
+		}
+		/*}}}*/
+		/*FUNCTION Duplicate{{{*/
+		SeqVec* Duplicate(void){
+
+			return new SeqVec(this->vector,this->M);
+
+		}
+		/*}}}*/
+		/*FUNCTION Set{{{*/
+		void Set(doubletype value){
+
+			int i;
+			for(i=0;i<this->M;i++)this->vector[i]=value;
+
+		}
+		/*}}}*/
+		/*FUNCTION AXPY{{{*/
+		void AXPY(SeqVec* X, doubletype a){
+
+			int i;
+
+			/*y=a*x+y where this->vector is y*/
+			for(i=0;i<this->M;i++)this->vector[i]=a*X->vector[i]+this->vector[i];
+
+		}
+		/*}}}*/
+		/*FUNCTION AYPX{{{*/
+		void AYPX(SeqVec* X, doubletype a){
+
+			int i;
+
+			/*y=x+a*y where this->vector is y*/
+			for(i=0;i<this->M;i++)this->vector[i]=X->vector[i]+a*this->vector[i];
+
+		}
+		/*}}}*/
+		/*FUNCTION ToMPISerial{{{*/
+		doubletype* ToMPISerial(void){
+
+			doubletype* buffer=NULL;
+
+			if(this->M){
+				buffer=xNew<doubletype>(this->M);
+				xMemCpy<doubletype>(buffer,this->vector,this->M);
+			}
+			return buffer;
+
+		}
+		/*}}}*/
+		/*FUNCTION Copy{{{*/
+		void Copy(SeqVec* to){
+
+			int i;
+
+			to->M=this->M;
+			for(i=0;i<this->M;i++)to->vector[i]=this->vector[i];
+
+		}
+		/*}}}*/
+		/*FUNCTION Norm{{{*/
+		doubletype Norm(NormMode mode){
+
+			doubletype norm;
+			int i;
+
+			switch(mode){
+				case NORM_INF:
+					norm=0; for(i=0;i<this->M;i++)norm=max(norm,fabs(this->vector[i]));
+					return norm;
+					break;
+				case NORM_TWO:
+					norm=0; 
+					for(i=0;i<this->M;i++)norm+=pow(this->vector[i],2);
+					return sqrt(norm);
+					break;
+				default:
+					_error_("unknown norm !");
+					break;
+			}
+		}
+		/*}}}*/
+		/*FUNCTION Scale{{{*/
+		void Scale(doubletype scale_factor){
+
+			int i;
+			for(i=0;i<this->M;i++)this->vector[i]=scale_factor*this->vector[i];
+
+		}
+		/*}}}*/
+		/*FUNCTION Dot{{{*/
+		doubletype Dot(SeqVec* input){
+
+			int i;
+
+			doubletype dot=0;
+			for(i=0;i<this->M;i++)dot+=this->vector[i]*input->vector[i];
+			return dot;
+
+		}
+		/*}}}*/
+		/*FUNCTION PointwiseDivide{{{*/
+		void PointwiseDivide(SeqVec* x,SeqVec* y){
+
+			int i;
+			/*pointwise w=x/y where this->vector is w: */
+			for(i=0;i<this->M;i++)this->vector[i]=x->vector[i]/y->vector[i];
+		}
 		/*}}}*/
 };
-
 #endif //#ifndef _SEQVEC_H_
Index: issm/trunk/src/c/toolkits/issm/issmtoolkit.h
===================================================================
--- issm/trunk/src/c/toolkits/issm/issmtoolkit.h	(revision 12709)
+++ issm/trunk/src/c/toolkits/issm/issmtoolkit.h	(revision 13395)
@@ -6,6 +6,4 @@
 #define _ISSM_TOOLKIT_H_
 
-#include "../../include/include.h"
-
 #include "./SeqMat.h"
 #include "./SeqVec.h"
Index: issm/trunk/src/c/toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp
===================================================================
--- issm/trunk/src/c/toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp	(revision 12709)
+++ issm/trunk/src/c/toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp	(revision 13395)
@@ -55,6 +55,10 @@
 			NULL, NULL, pnum_procs, tpwgts, options, &objval,epart, npart);
 
+	/*clean-up*/
+	xDelete<idx_t>(eptr);
+	xDelete<real_t>(tpwgts);
+
 	#else
-	_error2_("METIS version not supported yet");
+	_error_("METIS version not supported yet");
 	#endif
 }
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 13395)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 13395)
@@ -0,0 +1,170 @@
+/*!\file PetscMat.cpp
+ * \brief: implementation of the PetscMat object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../petscincludes.h"
+#include "../../../shared/shared.h"
+
+/*}}}*/
+
+/*PetscMat constructors and destructor*/
+/*FUNCTION PetscMat::PetscMat(){{{*/
+PetscMat::PetscMat(){
+	this->matrix=NULL;
+	#ifdef _HAVE_ADOLC_
+	this->amatrix=NULL;
+	#endif
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(int M,int N){{{*/
+PetscMat::PetscMat(int M,int N){
+
+	this->matrix=NewMat(M,N);
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(int M,int N, IssmDouble sparsity){{{*/
+PetscMat::PetscMat(int M,int N, IssmDouble sparsity){
+
+	this->matrix=NewMat(M,N,sparsity);
+}
+/*}}}*/
+/*FUNCTION PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){{{*/
+PetscMat::PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){
+
+	int     i;
+	int* idxm=NULL;
+	int* idxn=NULL;
+	
+	if(M)idxm=xNew<int>(M);
+	if(N)idxn=xNew<int>(N);
+
+	for(i=0;i<M;i++)idxm[i]=i;
+	for(i=0;i<N;i++)idxn[i]=i;
+
+
+	this->matrix=NewMat(M,N,sparsity);
+	MatSetValues(this->matrix,M,idxm,N,idxn,serial_mat,INSERT_VALUES);
+	MatAssemblyBegin(this->matrix,MAT_FINAL_ASSEMBLY);
+	MatAssemblyEnd(this->matrix,MAT_FINAL_ASSEMBLY);
+
+	xDelete<int>(idxm);
+	xDelete<int>(idxn);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(int M,int N, int connectivity, int numberofdofspernode){{{*/
+PetscMat::PetscMat(int M,int N, int connectivity,int numberofdofspernode){
+	
+	this->matrix=NewMat(M,N,connectivity,numberofdofspernode);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::~PetscMat(){{{*/
+PetscMat::~PetscMat(){
+	MatFree(&this->matrix);
+}
+/*}}}*/
+
+/*PetscMat specific routines: */
+/*FUNCTION PetscMat::Echo{{{*/
+void PetscMat::Echo(void){
+
+	MatView(this->matrix,PETSC_VIEWER_STDOUT_WORLD);
+}
+/*}}}*/
+/*FUNCTION PetscMat::Assemble{{{*/
+void PetscMat::Assemble(void){
+
+	_assert_(this->matrix);
+	MatAssemblyBegin(this->matrix,MAT_FINAL_ASSEMBLY);
+	MatAssemblyEnd(this->matrix,MAT_FINAL_ASSEMBLY);
+	#if _PETSC_MAJOR_ == 2 
+		MatCompress(this->matrix);
+	#endif
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::Norm{{{*/
+IssmDouble PetscMat::Norm(NormMode mode){
+
+
+	IssmDouble norm=0;
+	_assert_(this->matrix);
+	MatNorm(this->matrix,ISSMToPetscNormMode(mode),&norm);
+	
+	return norm;
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::GetSize{{{*/
+void PetscMat::GetSize(int* pM,int* pN){
+
+	_assert_(this->matrix);
+	MatGetSize(this->matrix,pM,pN);
+}
+/*}}}*/
+/*FUNCTION PetscMat::GetLocalSize{{{*/
+void PetscMat::GetLocalSize(int* pM,int* pN){
+
+	_assert_(this->matrix);
+	MatGetLocalSize(this->matrix,pM,pN);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::MatMult{{{*/
+void PetscMat::MatMult(PetscVec* X,PetscVec* AX){
+
+	_assert_(this->matrix);
+	_assert_(X->vector);
+	MatMultPatch(this->matrix,X->vector,AX->vector);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::Duplicate{{{*/
+PetscMat* PetscMat::Duplicate(void){
+
+	PetscMat* output=NULL;
+
+	output=new PetscMat();
+	_assert_(this->matrix);
+	MatDuplicate(this->matrix,MAT_COPY_VALUES,&output->matrix);
+
+	return output;
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::ToSerial{{{*/
+IssmDouble* PetscMat::ToSerial(void){
+
+	 IssmDouble* output=NULL;
+
+	 MatToSerial(&output,this->matrix);
+	 return output;
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::SetValues{{{*/
+void PetscMat::SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode){
+
+	MatSetValues(this->matrix,m,idxm,n,idxn,values,ISSMToPetscInsertMode(mode));
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::Convert{{{*/
+void PetscMat::Convert(MatrixType type){
+
+	MatConvert(this->matrix,ISSMToPetscMatrixType(type),MAT_REUSE_MATRIX,&this->matrix);
+
+}
+/*}}}*/
